(******************************************************************************)
(*     Alt-Ergo: The SMT Solver For Software Verification                     *)
(*     Copyright (C) 2013-2015 --- OCamlPro                                   *)
(*     This file is distributed under the terms of the CeCILL-C licence       *)
(******************************************************************************)

(******************************************************************************)
(*     The Alt-Ergo theorem prover                                            *)
(*     Copyright (C) 2006-2013                                                *)
(*     CNRS - INRIA - Universite Paris Sud                                    *)
(*                                                                            *)
(*     Sylvain Conchon                                                        *)
(*     Evelyne Contejean                                                      *)
(*                                                                            *)
(*     Francois Bobot                                                         *)
(*     Mohamed Iguernelala                                                    *)
(*     Stephane Lescuyer                                                      *)
(*     Alain Mebsout                                                          *)
(*                                                                            *)
(*   This file is distributed under the terms of the CeCILL-C licence         *)
(******************************************************************************)

module rec TX1 : sig
  include Polynome.T with type r = Shostak.r
end

and X1 : sig
  include Sig.SHOSTAK with type t = TX1.t
end

and X2 : sig
  include Sig.SHOSTAK with type t = Shostak.r Records.abstract
end

and X3 : sig
  include Sig.SHOSTAK with type t = Shostak.r Bitv.abstract
end

and X4 : sig
  include Sig.SHOSTAK with type t = Shostak.r Arrays.abstract
end

and X5 : sig
  include Sig.SHOSTAK with type t = Shostak.r Sum.abstract
end


and Shostak : sig
  include Sig.X

  val extract1 : r -> X1.t option
  val embed1 : X1.t -> r

  val extract2 : r -> X2.t option
  val embed2 : X2.t -> r

  val extract3 : r -> X3.t option
  val embed3 : X3.t -> r

  val extract4 : r -> X4.t option
  val embed4 : X4.t -> r

  val extract5 : r -> X5.t option
  val embed5 : X5.t -> r

end

module Use : Use.S with type r = Shostak.r

module Uf : Sig.UF_SIG with type r = Shostak.r
