(**************************************************************************)
(*                                                                        *)
(*     The Alt-ergo theorem prover                                        *)
(*     Copyright (C) 2006-2010                                            *)
(*                                                                        *)
(*     Sylvain Conchon                                                    *)
(*     Evelyne Contejean                                                  *)
(*     Stephane Lescuyer                                                  *)
(*     Mohamed Iguernelala                                                *)
(*     Alain Mebsout                                                      *)
(*     Cody Roux                                                          *)
(*                                                                        *)
(*     CNRS - INRIA - Universite Paris Sud                                *)
(*                                                                        *)
(*   This file is distributed under the terms of the CeCILL-C licence     *)
(*                                                                        *)
(**************************************************************************)

module type SIMPLEX =
  sig
    type r
    type p
    type state
    type pred = Eq | Ge | Le
    type result = Unsat | Unbound | Max of Numbers.Q.t * (Numbers.Q.t * r) list

    val empty : unit -> state
    val add_constraints : (p * pred * Numbers.Q.t) list -> state -> unit
    val maximize : p -> state -> result

  end



module Make (X : Sig.X) (P : Polynome.T with type r = X.r) :
  SIMPLEX with type r = X.r
          and type p  = P.t

