(******************************************************************************)
(*     Alt-Ergo: The SMT Solver For Software Verification                     *)
(*     Copyright (C) 2013-2015 --- OCamlPro                                   *)
(*     This file is distributed under the terms of the CeCILL-C licence       *)
(******************************************************************************)

(******************************************************************************)
(*     The Alt-Ergo theorem prover                                            *)
(*     Copyright (C) 2006-2013                                                *)
(*     CNRS - INRIA - Universite Paris Sud                                    *)
(*                                                                            *)
(*     Sylvain Conchon                                                        *)
(*     Evelyne Contejean                                                      *)
(*                                                                            *)
(*     Francois Bobot                                                         *)
(*     Mohamed Iguernelala                                                    *)
(*     Stephane Lescuyer                                                      *)
(*     Alain Mebsout                                                          *)
(*                                                                            *)
(*   This file is distributed under the terms of the CeCILL-C licence         *)
(******************************************************************************)

module type EXTENDED_RELATION = sig
  include RSig.RELATION
  module MP : Map.S
  val get_bounds : t -> Intervals.t MP.t
  val get_bound : MP.key -> t -> Intervals.t option
  val new_improved : t -> MP.key list
end

module Make
  (X : Sig.X)
  (Uf : Sig.UF_SIG with type r = X.r)
  (P : Polynome.EXTENDED_Polynome with type r = X.r)
  : EXTENDED_RELATION
  with type r = X.r and type uf = Uf.t and type MP.key = P.t
