(******************************************************************************)
(*     Alt-Ergo: The SMT Solver For Software Verification                     *)
(*     Copyright (C) 2013-2015 --- OCamlPro                                   *)
(*     This file is distributed under the terms of the CeCILL-C licence       *)
(******************************************************************************)

(******************************************************************************)
(*     The Alt-Ergo theorem prover                                            *)
(*     Copyright (C) 2006-2013                                                *)
(*     CNRS - INRIA - Universite Paris Sud                                    *)
(*                                                                            *)
(*     Sylvain Conchon                                                        *)
(*     Evelyne Contejean                                                      *)
(*                                                                            *)
(*     Francois Bobot                                                         *)
(*     Mohamed Iguernelala                                                    *)
(*     Stephane Lescuyer                                                      *)
(*     Alain Mebsout                                                          *)
(*                                                                            *)
(*   This file is distributed under the terms of the CeCILL-C licence         *)
(******************************************************************************)

open Format
open Options

module type SIG_OF_RELATION_WRAPPER = sig
  module Make
    (X : Sig.X)
    (Uf : Sig.UF_SIG with type r = X.r)
    (P : Polynome.EXTENDED_Polynome with type r = X.r)
    : RSig.RELATION with type r = X.r
		   (*      and type p = P.pos P.t*)
                   and type uf = Uf.t
end

module Relation : SIG_OF_RELATION_WRAPPER =
  (val
      if Options.use_fpa() then
          begin
            if Options.debug_fpa () then
              fprintf fmt "[arith.Relation] using module Gappa@.";
            (module Gappa : SIG_OF_RELATION_WRAPPER)
          end
       else
          begin
            if Options.debug_fpa () then
              fprintf fmt "[arith.Relation] using module IntervalCalculus@.";
            (module IntervalCalculus : SIG_OF_RELATION_WRAPPER)
          end
  )
