(******************************************************************************)
(*     Alt-Ergo: The SMT Solver For Software Verification                     *)
(*     Copyright (C) 2013-2015 --- OCamlPro                                   *)
(*     This file is distributed under the terms of the CeCILL-C licence       *)
(******************************************************************************)

(******************************************************************************)
(*     The Alt-Ergo theorem prover                                            *)
(*     Copyright (C) 2006-2013                                                *)
(*     CNRS - INRIA - Universite Paris Sud                                    *)
(*                                                                            *)
(*     Sylvain Conchon                                                        *)
(*     Evelyne Contejean                                                      *)
(*                                                                            *)
(*     Francois Bobot                                                         *)
(*     Mohamed Iguernelala                                                    *)
(*     Stephane Lescuyer                                                      *)
(*     Alain Mebsout                                                          *)
(*                                                                            *)
(*   This file is distributed under the terms of the CeCILL-C licence         *)
(******************************************************************************)

open Sig

module type RELATION = sig
  type t
  type r
  type uf
  val empty : Term.Set.t list -> t

  val assume : t -> uf -> (r input) list -> t * r result * Term.Set.t
  val query  : t -> uf -> r input -> Sig.answer

  val case_split : t -> uf -> (r Literal.view * lit_origin) list
  (** case_split env returns a list of equalities *)

  val add : t -> uf -> Term.t -> r -> t * r fact list
  (** add a representant to take into account *)

  val print_model : Format.formatter -> t -> (Term.t * r) list -> unit

  val new_terms : t -> Term.Set.t
end
