(******************************************************************************)
(*     Alt-Ergo: The SMT Solver For Software Verification                     *)
(*     Copyright (C) 2013-2015 --- OCamlPro                                   *)
(*     This file is distributed under the terms of the CeCILL-C licence       *)
(******************************************************************************)

module FPA : sig
  val prelude : unit -> string

  val is_rounding_mode : Term.t -> bool

  val ty_mode : Ty.t

  (*  why3/standard rounding modes*)

  val _NearestTiesToEven__rounding_mode : Term.t
  (** ne in Gappa: to nearest, tie breaking to even mantissas*)

  val _ToZero__rounding_mode : Term.t
  (** zr in Gappa: toward zero *)

  val _Up__rounding_mode : Term.t
  (** up in Gappa: toward plus infinity *)

  val _Down__rounding_mode : Term.t
  (** dn in Gappa: toward minus infinity *)

  val _NearestTiesToAway__rounding_mode : Term.t
  (** na : to nearest, tie breaking away from zero *)

  (* additional Gappa rounding modes *)

  val _Aw__rounding_mode : Term.t
  (** aw in Gappa: away from zero **)

  val _Od__rounding_mode : Term.t
  (** od in Gappa: to odd mantissas *)

  val _No__rounding_mode : Term.t
  (** no in Gappa: to nearest, tie breaking to odd mantissas *)

  val _Nz__rounding_mode : Term.t
  (** nz in Gappa: to nearest, tie breaking toward zero *)

  val _Nd__rounding_mode : Term.t
  (** nd in Gappa: to nearest, tie breaking toward minus infinity *)

  val _Nu__rounding_mode : Term.t
  (** nu in Gappa: to nearest, tie breaking toward plus infinity *)

end
