(**************************************************************************)
(*                                                                        *)
(*     The Alt-ergo theorem prover                                        *)
(*     Copyright (C) 2006-2010                                            *)
(*                                                                        *)
(*     Sylvain Conchon                                                    *)
(*     Evelyne Contejean                                                  *)
(*     Stephane Lescuyer                                                  *)
(*     Mohamed Iguernelala                                                *)
(*     Alain Mebsout                                                      *)
(*     Cody Roux                                                          *)
(*                                                                        *)
(*     CNRS - INRIA - Universite Paris Sud                                *)
(*                                                                        *)
(*   This file is distributed under the terms of the CeCILL-C licence     *)
(*                                                                        *)
(**************************************************************************)

exception Infinity

(* should be updated: return a Numbers.Q.t *)
val log_2 : Numbers.Q.t -> int

(* mantissa size on which we can represent the given number,
   or Infinity *)
val mantissa : Numbers.Q.t -> int


(*[compute_error prec exp mode x]
  error distance between x and round(x) *)
val compute_error :
  Numbers.Q.t -> Numbers.Q.t -> Term.t -> Numbers.Q.t -> Numbers.Q.t


(* [float_of_const prec exp mode x] float approx of a real constant *)
val float_of_const :
  Numbers.Q.t -> Numbers.Q.t -> Term.t -> Numbers.Q.t -> Numbers.Q.t


(* [fix_of_const prec mode x] fixe-point approx of a real constant *)
val fix_of_const :
  Numbers.Q.t -> Term.t -> Numbers.Q.t -> Numbers.Q.t


(*[maybe_sqrt r] returns the sqrt of (numerator r) / sqrt of (denumenator r)
  if the sqrts have no reminders, or None otherwise*)
val maybe_sqrt : Numbers.Q.t -> Numbers.Q.t option

