
let profile = Options.debug_fpa()

let nass = ref 0
let nsatur = ref 0
let nsmplx = ref 0
let nlems = ref 0
let nterms = ref 0

module type S = sig
  val start : unit -> unit
  val get : unit -> unit
  val total : unit -> float
  val last : unit -> float
end

module Time ( X : sig end ) = struct

  open Unix

  let mark = ref 0.0
  let tot  = ref 0.0
  let diff = ref 0.0
  let last () = !diff
  let total () = !tot

  let start () =
    if profile then
      mark := (times()).tms_utime

  let get () =
    if profile then
      let t = (times()).tms_utime in
      let d = t -. !mark in
      tot := !tot +. d;
      diff := d;
      mark := t
end

module SimplexTime = Time(struct end)
module SaturateTime = Time(struct end)
module GraphTime = Time(struct end)
module HammerTime = Time(struct end)
